#define button		3 //кнопка
#define modeSwitch	4 //переключатель прерывисто/постоянно
#define led			2 //светодиоды

#define baseOCR1C	161 //24,5кГц примерно, можно менять плюс/минус несколько единиц для подгонки частоты

void setup() {
	pinMode(0, OUTPUT);// _OC1A
	pinMode(1, OUTPUT);//  OC1A

	pinMode(led, OUTPUT);//светодиоды
	pinMode(button, INPUT_PULLUP);//низкий уровень - генерация 25кГц
	pinMode(modeSwitch, INPUT_PULLUP);//низкий уровень - прерывистая генерация

	setupTimer();	
}

void setupTimer() {
	noInterrupts();
	/*timer 1*/
	// Clear registers
	TCNT1 = 0;
	TCCR1 = 0;


	OCR1C = baseOCR1C;
	OCR1A = OCR1C/2;

	// PWM 1A
	TCCR1 |= (1 << PWM1A);

	//подключение выходов Toggle the OC1A output line.
	//TCCR1 |= (1 << COM1A0);
	// Prescaler 16
	TCCR1 |= (1 << CS12) | (1 << CS10);

	//deadtime
	DTPS1 = 1<<DTPS11 | 1<<DTPS10;
	DT1A = 1<<DT1AH3 | 1<<DT1AH2 | 1<<DT1AH1 | 1<<DT1AH0 | 1<<DT1AL3 | 1<<DT1AL2 | 1<<DT1AL1 | 1<<DT1AL0;


	/*timer 0*/
	// Clear registers
	TCCR0A = 0;
	TCCR0B = 0;
	TCNT0 = 0;
	// 32.01844262295082 Hz (8000000/((243+1)*1024))
	OCR0A = 243;
	// CTC
	TCCR0A |= (1 << WGM01);
	// Prescaler 1024
	TCCR0B |= (1 << CS02) | (1 << CS00);
	// Output Compare Match A Interrupt Enable
	TIMSK |= (1 << OCIE0A);
	
	interrupts();
}

ISR(TIMER0_COMPA_vect) {
	//32Гц
	volatile static uint8_t i=0;
	if(i++>0)//делитель частоты вдвое
		{
		//16Гц
		i=0;
		if(!digitalRead(button))//кнопка нажата
			{
			//подключить PWM 25кГц	
			if(!digitalRead(modeSwitch))//переключатель в положении "прерывисто"
				{	
				digitalWrite(led, digitalRead(led) ^ 1);//инвертировать вывод
				if(digitalRead(led))
					{
					TCNT1 = 0;
					TCCR1 |= (1 << COM1A0);	//подключить выходы OC1A и _OC1A
					}	
				else
					{
					TCCR1 &= (~(1 << COM1A0));//ОТключить выходы OC1A и _OC1A
					}			
				}
			else
				{
				//переключатель в положении "постоянно"
				TCCR1 |= (1 << COM1A0);	//подключить выходы OC1A и _OC1A
				digitalWrite(led, 1);
				}
			}
		else
			{
			//отключить PWM 25кГц	
			TCCR1 &= (~(1 << COM1A0));//ОТключить выходы OC1A и _OC1A
			digitalWrite(led, 0);
			}
		}
}

void loop() {
}